<!-- 
Licensed to the Apache Software Foundation (ASF) under one
or more contributor license agreements.  See the NOTICE file
distributed with this work for additional information
regarding copyright ownership.  The ASF licenses this file
to you under the Apache License, Version 2.0 (the
"License"); you may not use this file except in compliance
with the License.  You may obtain a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing,
software distributed under the License is distributed on an
"AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, either express or implied.  See the License for the
specific language governing permissions and limitations
under the License.
-->


# Build the website for Doris documentations

## Prerequisites

1. Install PiPy (If not installed)

    ```
    curl https://bootstrap.pypa.io/get-pip.py -o get-pip.py
    python get-pip.py
    ```

2. Install sphinx and other dependencies

    ```
    pip install sphinx                      # Sphinx main program
    pip install recommonmark                # Sphinx markdown extension
    pip install sphinx-markdown-tables      # Sphinx markdown table render extension
    pip install jieba                       # Sphinx Chinese tokenizer
    pip install sphinx_rtd_theme            # Sphinx Read-the-Docs theme
    ```

## Build the website

```
sh build_site.sh 
```

## Start web server

```
cd build/html/
nohup python -m SimpleHTTPServer &
```

You can start any web server you like.

## Browse website

```
http://localhost:8000/
```
